function [f0,alpha0,U0,z,f,alphas]=hyper_mc(X,m,pmfunc,varargin)

%initialize
[n,d]=size(X);
H=varargin{1};

%density estimate - data
fprintf('Computing density estimate of the data...\n')
f0=feval(pmfunc,X,varargin{:}); f0=f0(:,end);
fprintf('done\n');

%density estimate - random sample
fprintf('Sampling from the product of marginals...\n')
fail=1:m;
while length(fail)>0
    zMC=rand(length(fail),d);
    z(fail,:)=zMC<repmat(H(1,:),length(fail),1);
    fail=find(sum(z,2)<0);
end
z_mu=rand(m,d); z_mu=z_mu>.5;
f=feval(pmfunc,z,varargin{:}); f=f(:,end);
f_mu=feval(pmfunc,z_mu,varargin{:}); f_mu=f_mu(:,end);

%sw=rand(m,1); sw=sw>.1;
%z_g=z; aux=find(sw); z_g(aux,:)=z_mu(aux,:);
%f_g=feval(pmfunc,z_g,varargin{:}); f_g=f_g(:,end);


fprintf('done.\n');



%accept/reject
fprintf('Computing MC measure estimates...\n');
alphas=zeros(1,m);
for k=1:m
    if mod(k,10000)==0, fprintf('   F measure (MC sample)... %d/%d\n',k,m), end
    accepted=find(f<=f(k));
    alphas(k)=length(accepted)/m;
end

alpha0=zeros(1,n);
for k=1:n
    if mod(k,10000)==0, fprintf('   F measure (data)... %d/%d\n',k,n), end
    accepted=find(f<=f0(k));
    alpha0(k)=length(accepted)/m;
end

U0=zeros(1,n);
for k=1:n
    if mod(k,10000)==0, fprintf('   U measure (data)... %d/%d\n',k,n), end
    accepted=find(f_mu<=f0(k));
    U0(k)=length(accepted)/m;
end
fprintf('done.\n');
