%==========================================================================
% Plots for comparing all methods.
%==========================================================================

figure(9);clf;

% Plot offsets, in order (bottom to top):
% - gamma_i, eta_i, L1O-kNNG, OCSVM_Gauss, OCSVM_AA, Ground truth
methods=[0 1 run_l1oknng run_ocsvm_gauss run_ocsvm_aa 1];
s=cumsum(methods);
d = .5;
ind=1:n;
ground_truth=anomalZtrue;


h=stem(s(6)+s(6)*d+ground_truth(ind),'b');set(h,'LineWidth',2,'BaseValue',s(6)+s(6)*d);
text(-10,s(6)*(d+1),'Ground Truth','Rotation',90,'FontName','Times','FontSize',14);
hold on

if run_ocsvm_aa
    h=stem(s(5)+s(5)*d+ocsvm_aa_yhat_i(ind),'r');set(h,'LineWidth',2,'BaseValue',s(5)+s(5)*d);
    text(-10,s(5)*(d+1),'OCSVM (AA)','Rotation',90,'FontName','Times','FontSize',14);
end


if run_ocsvm_gauss
    h=stem(s(4)+s(4)*d+ocsvm_gauss_yhat_i(ind),'r');set(h,'LineWidth',2,'BaseValue',s(4)+s(4)*d);
    text(-10,s(4)*(d+1),'OCSVM (Gauss.)','Rotation',90,'FontName','Times','FontSize',14);
end

if run_l1oknng
    h=stem(s(3)+s(3)*d+loo_kmst_score_i(ind),'c');set(h,'LineWidth',2,'BaseValue',s(3)+s(3)*d);
    text(-10,s(3)*(d+1),'LOO-kNNG','Rotation',90,'FontName','Times','FontSize',14);
end

h=stem(1+d+eta_i(ind),'g');set(h,'LineWidth',2,'BaseValue',1+1*d);
text('Interpreter','latex',...
 'String','$$\widehat{\eta}$$',...
 'Position',[-10,1*(d+1)+.5],...
 'FontSize',14,'Rotation',90);

h=stem(gamma_i(ind),'k');set(h,'LineWidth',2,'BaseValue',0);
text('Interpreter','latex',...
 'String','$$\widehat{\gamma}$$',...
 'Position',[-10,0*(d+1)+.5],...
 'FontSize',14,'Rotation',90);

set(gca,'FontName','Times','FontSize',14);
yticks=[0 1 1+d 2+d 2*(1+d) 1+2*(1+d) 3*(1+d) 1+3*(1+d) 4*(1+d) 1+4*(1+d) 5*(1+d) 1+5*(1+d)];
set(gca,'YTick',yticks(1:6+2*sum(methods(3:5))));
set(gca,'YTickLabel',repmat([0 1],1,3+sum(methods(3:5))));

xlabel('Observation Index');